UM .NET API 6.17.1

- Main Page
- Related Pages
- Packages
- Classes

- Class List
- Class Hierarchy
- Class Members

Classes | Public Member Functions | List of all members
com.latencybusters.lbm.LBMSourceStatistics Class Reference

LBM Source Transport Statistics. More...

Inheritance diagram for com.latencybusters.lbm.LBMSourceStatistics:

## Public Member Functions
| LBMSourceStatistics ()
| Instantiate an empty object containing no statistics. More...
unsafe | LBMSourceStatistics (LBMContext lbmctx, int maxStats)
| Instantiate object containing the current set of source transport statistics for a given LBM source. More...
unsafe | LBMSourceStatistics (LBMSource lbmsrc)
| Instantiate object containing the current set of source transport statistics for a given LBM source. More...
void | Dispose ()
| Free memory associated with this set of statistics.
void | dispose ()
| Free memory associated with this set of statistics (same as Dispose()). More...
unsafe void | refresh (LBMContext lbmctx, int maxStats)
| Refresh the current set of source transport statistics for a given LBM source. More...
unsafe void | refresh (LBMSource lbmsrc)
| Refresh the current set of source transport statistics for a given LBM source. More...
int | size ()
| Number of statistical sets encapsulated within this object. More...
int | type ()
| Transport type (TCP, LBT-RM, LBT-RU, etc.) More...
int | type (int n)
| Transport type (TCP, LBT-RM, LBT-RU, etc.) More...
string | typeName ()
| Transport type name (TCP, LBT-RM, LBT-RU, etc.). More...
string | typeName (int n)
| Transport type name (TCP, LBT-RM, LBT-RU, etc.). More...
string | source ()
| Source of transport as a string. More...
string | source (int n)
| Source of transport as a string. More...
long | numberOfClients ()
| Number of receiver clients currently connected over this transport (TCP, LBT-RU, LBT-IPC, LBT-RDMA). More...
long | numberOfClients (int n)
| Number of receiver clients currently connected over this transport (TCP, LBT-RU, LBT-IPC, LBT-RDMA). More...
long | bytesBuffered ()
| Number of bytes currently in UM's TCP buffer (TCP only) More...
long | bytesBuffered (int n)
| Number of bytes currently in UM's TCP buffer (TCP only) More...
long | messagesSent ()
| Number of datagrams sent (LBT-RM, LBT-RU, LBT-IPC, LBT-RDMA) or complete messages sent (BROKER). More...
long | messagesSent (int n)
| Number of datagrams sent (LBT-RM, LBT-RU, LBT-IPC, LBT-RDMA) or complete messages sent (BROKER). More...
long | bytesSent ()
| Number of datagram bytes sent (LBT-RM, LBT-RU, LBT-IPC, LBT-RDMA) or complete message bytes sent (BROKER). More...
long | bytesSent (int n)
| Number of datagram bytes sent (LBT-RM, LBT-RU, LBT-IPC, LBT-RDMA) or complete message bytes sent (BROKER). More...
long | transmissionWindowMessages ()
| Number of datagrams in the transmission window (LBT-RM only). More...
long | transmissionWindowMessages (int n)
| Number of datagrams in the transmission window (LBT-RM only). More...
long | transmissionWindowBytes ()
| Number of bytes currently in the transmission window (LBT-RM only) More...
long | transmissionWindowBytes (int n)
| Number of bytes currently in the transmission window (LBT-RM only) More...
long | nakPacketsReceived ()
| Number of NAK packets received by this source transport (LBT-RM, LBT-RU). More...
long | nakPacketsReceived (int n)
| Number of NAK packets received by this source transport (LBT-RM, LBT-RU). More...
long | naksReceived ()
| Number of individual NAKs received by the source transport (LBT-RM, LBT-RU). More...
long | naksReceived (int n)
| Number of individual NAKs received by the source transport (LBT-RM, LBT-RU). More...
long | naksIgnored ()
| Number of NAKs this source transport ignored and sent an NCF with reason code "ignored" (LBT-RM, LBT-RU). More...
long | naksIgnored (int n)
| Number of NAKs this source transport ignored and sent an NCF with reason code "ignored" (LBT-RM, LBT-RU). More...
long | naksShed ()
| Number of NAKs this source transport has shed and sent an NCF with reason code "shed" (LBT-RM, LBT-RU). More...
long | naksShed (int n)
| Number of NAKs this source transport has shed and sent an NCF with reason code "shed" (LBT-RM, LBT-RU). More...
long | naksIgnoredRetransmitDelay ()
| Number of NAKs this source transport has not processed because it met its retransmission rate limit (LBT-RM, LBT-RU). More...
long | naksIgnoredRetransmitDelay (int n)
| Number of NAKs this source transport has not processed because it met its retransmission rate limit (LBT-RM, LBT-RU). More...
long | retransmissionsSent ()
| Number of datagrams retransmitted by this source (LBT-RM, LBT-RU). More...
long | retransmissionsSent (int n)
| Number of datagrams retransmitted by this source (LBT-RM, LBT-RU). More...
long | messagesQueued ()
| Number of datagrams currently queued by the rate limiter (LBT-RM only). More...
long | messagesQueued (int n)
| Number of datagrams currently queued by the rate limiter (LBT-RM only). More...
long | retransmissionsQueued ()
| Number of retransmission datagrams currently queued by the retransmit rate limiter (LBT-RM only). More...
long | retransmissionsQueued (int n)
| Number of retransmission datagrams currently queued by the retransmit rate limiter (LBT-RM only). More...
long | retransmissionBytesSent ()
| Number of bytes retransmitted by this source transport (LBT-RU, LBT-RM). More...
long | retransmissionBytesSent (int n)
| Number of bytes retransmitted by this source transport (LBT-RU, LBT-RM). More...
string | getApplicationSourceId ()
| Retrieve the application source identifier associated with this set of statistics. More...
IPAddress | getSender ()
| Retrieve the IP sender address associated with this set of statistics. More...
DateTime | getTimestamp ()
| Retrieve the timestamp associated with this set of statistics. More...
long | getProcessId ()
| Retrieve the sender process ID associated with this set of statistics. More...
long | getContextId ()
| Retrieve the sender context ID associated with this set of statistics. More...
long | getObjectId ()
| Retrieve the sender object ID associated with this set of statistics. More...
long | getSource ()
| Retrieve the source attribute from the statistics attribute block associated with this set of statistics. More...

## Detailed Description

LBM Source Transport Statistics.

This object provides user monitoring with access to statistics of an application being monitored. The user monitoring code can be part of the application being monitored (i.e. the application can be "self-monitoring"), or the monitoring code can be remote, using the lbmmon infrastructure to deliver statistics. Note that when stats are sampled, the fields in the structure are not necessarily from the same instant in time. The structure might be updated concurrently with it being sampled, and while each structure field is atomically read, the field values can be skewed slightly across time.

## Constructor & Destructor Documentation

com.latencybusters.lbm.LBMSourceStatistics.LBMSourceStatistics | ( |  | ) |

Instantiate an empty object containing no statistics.

See also
  refresh

unsafe com.latencybusters.lbm.LBMSourceStatistics.LBMSourceStatistics | ( | LBMContext | lbmctx,
|  | int | maxStats
| ) |  |

Instantiate object containing the current set of source transport statistics for a given LBM source.

This constructor will throw LBMEInvalException if maxStats is less than the the available number of transport statistical sets.

See also
  refresh

Parameters

  lbmctx | LBMContext object associated with statistics to be retrieved
  maxStats | Maximum number of statistical sets to retrieve

unsafe com.latencybusters.lbm.LBMSourceStatistics.LBMSourceStatistics | ( | LBMSource | lbmsrc | ) |

Instantiate object containing the current set of source transport statistics for a given LBM source.

See also
  refresh

Parameters

  lbmsrc | LBMSource object

## Member Function Documentation

long com.latencybusters.lbm.LBMSourceStatistics.bytesBuffered | ( |  | ) |

Number of bytes currently in UM's TCP buffer (TCP only)

This count is affected by the number of receivers,and configuration options transport_tcp_multiple_receiver_behavior and transport_session_maximum_buffer. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Number of bytes currently in UM's TCP buffer, i.e., a snapshot.

long com.latencybusters.lbm.LBMSourceStatistics.bytesBuffered | ( | int | n | ) |

Number of bytes currently in UM's TCP buffer (TCP only)

This count is affected by the number of receivers,and configuration options transport_tcp_multiple_receiver_behavior and transport_session_maximum_buffer. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of bytes currently in UM's TCP buffer, i.e., a snapshot.

long com.latencybusters.lbm.LBMSourceStatistics.bytesSent | ( |  | ) |

Number of datagram bytes sent (LBT-RM, LBT-RU, LBT-IPC, LBT-RDMA) or complete message bytes sent (BROKER).

Includes the total length of all transport packets, including UM header information (except BROKER). This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Number of datagram bytes sent, i.e., the total of lengths of all packets including UM header information.

long com.latencybusters.lbm.LBMSourceStatistics.bytesSent | ( | int | n | ) |

Number of datagram bytes sent (LBT-RM, LBT-RU, LBT-IPC, LBT-RDMA) or complete message bytes sent (BROKER).

Includes the total length of all transport packets, including UM header information (except BROKER). This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of datagram bytes sent, i.e., the total of lengths of all packets including UM header information.

void com.latencybusters.lbm.LBMSourceStatistics.dispose | ( |  | ) |

Free memory associated with this set of statistics (same as Dispose()).

See also
  Dispose

Referenced by com.latencybusters.lbm.LBMObjectRecycler.close().

string com.latencybusters.lbm.LBMStatistics.getApplicationSourceId | ( |  | ) |
| inherited

Retrieve the application source identifier associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Application source ID

long com.latencybusters.lbm.LBMStatistics.getContextId | ( |  | ) |
| inherited

Retrieve the sender context ID associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Sender context ID

long com.latencybusters.lbm.LBMStatistics.getObjectId | ( |  | ) |
| inherited

Retrieve the sender object ID associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Sender object ID

long com.latencybusters.lbm.LBMStatistics.getProcessId | ( |  | ) |
| inherited

Retrieve the sender process ID associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Sender process ID

IPAddress com.latencybusters.lbm.LBMStatistics.getSender | ( |  | ) |
| inherited

Retrieve the IP sender address associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  IPAddress object corresponding to the statistics' sender IP address

long com.latencybusters.lbm.LBMStatistics.getSource | ( |  | ) |
| inherited

Retrieve the source attribute from the statistics attribute block associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value. Compare return value to LBMMonitor.ATTR_SOURCE_NORMAL and LBMMonitor.ATTR_SOURCE_IM.

Returns
  Sender source flag

DateTime com.latencybusters.lbm.LBMStatistics.getTimestamp | ( |  | ) |
| inherited

Retrieve the timestamp associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  DateTime object

long com.latencybusters.lbm.LBMSourceStatistics.messagesQueued | ( |  | ) |

Number of datagrams currently queued by the rate limiter (LBT-RM only).

When a source transport attempts to send messages (any type) faster than its data rate limiter allows (set by configuration option transport_lbtrm_data_rate_limit, default 10Mbps), the data rate limiter queues the messages until they can be sent within the data rate limit. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Number of datagrams currently queued by the rate limiter.

long com.latencybusters.lbm.LBMSourceStatistics.messagesQueued | ( | int | n | ) |

Number of datagrams currently queued by the rate limiter (LBT-RM only).

When a source transport attempts to send messages (any type) faster than its data rate limiter allows (set by configuration option transport_lbtrm_data_rate_limit, default 10Mbps), the data rate limiter queues the messages until they can be sent within the data rate limit. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of datagrams currently queued by the rate limiter.

long com.latencybusters.lbm.LBMSourceStatistics.messagesSent | ( |  | ) |

Number of datagrams sent (LBT-RM, LBT-RU, LBT-IPC, LBT-RDMA) or complete messages sent (BROKER).

Depending on batching settings, a single datagram may contain one or more messages, or a fragment of a larger message. Larger messages are split into fragment sizes limited by their transport's configuration option setting. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Number of datagrams sent.

long com.latencybusters.lbm.LBMSourceStatistics.messagesSent | ( | int | n | ) |

Number of datagrams sent (LBT-RM, LBT-RU, LBT-IPC, LBT-RDMA) or complete messages sent (BROKER).

Depending on batching settings, a single datagram may contain one or more messages, or a fragment of a larger message. Larger messages are split into fragment sizes limited by their transport's configuration option setting. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of datagrams sent.

long com.latencybusters.lbm.LBMSourceStatistics.nakPacketsReceived | ( |  | ) |

Number of NAK packets received by this source transport (LBT-RM, LBT-RU).

UM batches NAKs into NAK packets to save network bandwidth. This should always be less than or equal to naksReceived (below). This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Number of NAK packets received by this source transport.

long com.latencybusters.lbm.LBMSourceStatistics.nakPacketsReceived | ( | int | n | ) |

Number of NAK packets received by this source transport (LBT-RM, LBT-RU).

UM batches NAKs into NAK packets to save network bandwidth. This should always be less than or equal to naksReceived (below). This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of NAK packets received by this source transport.

long com.latencybusters.lbm.LBMSourceStatistics.naksIgnored | ( |  | ) |

Number of NAKs this source transport ignored and sent an NCF with reason code "ignored" (LBT-RM, LBT-RU).

A source transport ignores a NAK for a datagram it has already recently retransmitted. How "recently" is determined by the configuration option source transport_lbtrm_ignore_interval (default 500ms). If this count is high, a receiver transport may be having trouble receiving retransmissions, or the ignore interval may be set too long. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Number of NAKs this source transport ignored and sent an NCF with reason code set to "ignored".

long com.latencybusters.lbm.LBMSourceStatistics.naksIgnored | ( | int | n | ) |

Number of NAKs this source transport ignored and sent an NCF with reason code "ignored" (LBT-RM, LBT-RU).

A source transport ignores a NAK for a datagram it has already recently retransmitted. How "recently" is determined by the configuration option source transport_lbtrm_ignore_interval (default 500ms). If this count is high, a receiver transport may be having trouble receiving retransmissions, or the ignore interval may be set too long. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of NAKs this source transport ignored and sent an NCF with reason code set to "ignored".

long com.latencybusters.lbm.LBMSourceStatistics.naksIgnoredRetransmitDelay | ( |  | ) |

Number of NAKs this source transport has not processed because it met its retransmission rate limit (LBT-RM, LBT-RU).

This rate limit is set by configuration option transport_lbtrm_retransmit_rate_limit (default 5Mbps). For each of these NAKs, the source transport immediately sends an NFC rx_delay, then queues the retransmission for a later send within the rate limit. If this count is high, one or more crybaby receiver transports may be clogging the source transport's retransmit queue. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Number of NAKs this source did not process because doing so would exceed its retransmit rate limit.

long com.latencybusters.lbm.LBMSourceStatistics.naksIgnoredRetransmitDelay | ( | int | n | ) |

Number of NAKs this source transport has not processed because it met its retransmission rate limit (LBT-RM, LBT-RU).

This rate limit is set by configuration option transport_lbtrm_retransmit_rate_limit (default 5Mbps). For each of these NAKs, the source transport immediately sends an NFC rx_delay, then queues the retransmission for a later send within the rate limit. If this count is high, one or more crybaby receiver transports may be clogging the source transport's retransmit queue. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of NAKs this source did not process because doing so would exceed its retransmit rate limit.

long com.latencybusters.lbm.LBMSourceStatistics.naksReceived | ( |  | ) |

Number of individual NAKs received by the source transport (LBT-RM, LBT-RU).

When a source transport receives a NAK from a receiver transport, it may respond by re-transmitting the requested datagram, or it may send an NCF. The NAKing receiver transport responds to the NCF by waiting (timeout set by the transport's NAK suppress interval option, default 1000 ms), then re-sending the NAK. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Number of individual NAKs received by the source transport.

long com.latencybusters.lbm.LBMSourceStatistics.naksReceived | ( | int | n | ) |

Number of individual NAKs received by the source transport (LBT-RM, LBT-RU).

When a source transport receives a NAK from a receiver transport, it may respond by re-transmitting the requested datagram, or it may send an NCF. The NAKing receiver transport responds to the NCF by waiting (timeout set by the transport's NAK suppress interval option, default 1000 ms), then re-sending the NAK. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of individual NAKs received by the source transport.

long com.latencybusters.lbm.LBMSourceStatistics.naksShed | ( |  | ) |

Number of NAKs this source transport has shed and sent an NCF with reason code "shed" (LBT-RM, LBT-RU).

When a source transport's retransmit rate limiter and retransmit queue are both at maximum, it responds to a NAK by sending an "NCF shed", and does not retransmit. The receiver transport should wait, then send another NAK. If this count is high, one or more crybaby receiver transports may be clogging the source transport's retransmit queue. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Number of NAKs this source transport has shed and sent an NCF with the reason code set to "shed".

long com.latencybusters.lbm.LBMSourceStatistics.naksShed | ( | int | n | ) |

Number of NAKs this source transport has shed and sent an NCF with reason code "shed" (LBT-RM, LBT-RU).

When a source transport's retransmit rate limiter and retransmit queue are both at maximum, it responds to a NAK by sending an "NCF shed", and does not retransmit. The receiver transport should wait, then send another NAK. If this count is high, one or more crybaby receiver transports may be clogging the source transport's retransmit queue. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of NAKs this source transport has shed and sent an NCF with the reason code set to "shed".

long com.latencybusters.lbm.LBMSourceStatistics.numberOfClients | ( |  | ) |

Number of receiver clients currently connected over this transport (TCP, LBT-RU, LBT-IPC, LBT-RDMA).

This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Number of receiver clients currently connected over this transport.

long com.latencybusters.lbm.LBMSourceStatistics.numberOfClients | ( | int | n | ) |

Number of receiver clients currently connected over this transport (TCP, LBT-RU, LBT-IPC, LBT-RDMA).

This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of receiver clients currently connected over this transport.

unsafe void com.latencybusters.lbm.LBMSourceStatistics.refresh | ( | LBMContext | lbmctx,
|  | int | maxStats
| ) |  |

Refresh the current set of source transport statistics for a given LBM source.

This method will throw LBMEInvalException if maxStats is less than the the available number of transport statistical sets.

Parameters

  lbmctx | LBMContext object associated with statistics to be retrieved
  maxStats | Maximum number of statistical sets to retrieve

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

Referenced by com.latencybusters.lbm.LBMContext.getSourceStatistics(), and com.latencybusters.lbm.LBMSource.getStatistics().

unsafe void com.latencybusters.lbm.LBMSourceStatistics.refresh | ( | LBMSource | lbmsrc | ) |

Refresh the current set of source transport statistics for a given LBM source.

Parameters

  lbmsrc | LBMSource object

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.
  com.latencybusters.lbm.LBMEOPException | Unknown transport
  com.latencybusters.lbm.LBMEInvalException | Statistics not found

References com.latencybusters.lbm.LBM.EINVAL, com.latencybusters.lbm.LBM.EOP, com.latencybusters.lbm.LBM.errorMessage(), com.latencybusters.lbm.LBM.errorNumber(), com.latencybusters.lbm.LBM.TRANSPORT_STAT_BROKER, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTIPC, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRDMA, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRM, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRU, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTSMX, and com.latencybusters.lbm.LBM.TRANSPORT_STAT_TCP.

long com.latencybusters.lbm.LBMSourceStatistics.retransmissionBytesSent | ( |  | ) |

Number of bytes retransmitted by this source transport (LBT-RU, LBT-RM).

This count is triggered under the same circumstances as retransmissionsSent, above. In a normal, light-loss scenario, most NAKs received induce a retransmission. When losses become heavy and/or many receiver transports begin losing the same datagrams, NCF-related no-retransmit counts (naksIgnored, naksShed and naksIgnoredRetransmitDelay) may begin to inflate, and retransmissions retransmissionsSent) may become significantly lower than NAKs received (naksReceived). This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Total number of bytes retransmitted by this source transport.

long com.latencybusters.lbm.LBMSourceStatistics.retransmissionBytesSent | ( | int | n | ) |

Number of bytes retransmitted by this source transport (LBT-RU, LBT-RM).

This count is triggered under the same circumstances as retransmissionsSent, above. In a normal, light-loss scenario, most NAKs received induce a retransmission. When losses become heavy and/or many receiver transports begin losing the same datagrams, NCF-related no-retransmit counts (naksIgnored, naksShed and naksIgnoredRetransmitDelay) may begin to inflate, and retransmissions retransmissionsSent) may become significantly lower than NAKs received (naksReceived). This method returns a value from the nth set of statistics encapsulated within this object.

See also
  LBMSourceStatistics(LBMSource)

Parameters

  n | Statistics set index

Returns
  Total number of bytes retransmitted by this source transport.

long com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued | ( |  | ) |

Number of retransmission datagrams currently queued by the retransmit rate limiter (LBT-RM only).

When a source transport attempts to send retransmissions faster that its retransmit rate limiter allows (set by configuration option transport_lbtrm_retransmit_rate_limit, default 5Mbps), the retransmit rate limiter queues retransmissions until they can be sent within the rate limit. naksIgnoredRetransmitDelay (above) will generally also rise if this count is high. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Number of retransmission datagrams currently queued by the retransmit rate limiter.

long com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued | ( | int | n | ) |

Number of retransmission datagrams currently queued by the retransmit rate limiter (LBT-RM only).

When a source transport attempts to send retransmissions faster that its retransmit rate limiter allows (set by configuration option transport_lbtrm_retransmit_rate_limit, default 5Mbps), the retransmit rate limiter queues retransmissions until they can be sent within the rate limit. naksIgnoredRetransmitDelay (above) will generally also rise if this count is high. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of retransmission datagrams currently queued by the retransmit rate limiter.

long com.latencybusters.lbm.LBMSourceStatistics.retransmissionsSent | ( |  | ) |

Number of datagrams retransmitted by this source (LBT-RM, LBT-RU).

This count is incremented under the same circumstances as retransmissionBytesSent, below. In a normal, light-loss scenario, most NAKs received induce a retransmission. When losses become heavy and/or many receiver transports begin losing the same datagrams, NCF-related no-retransmit counts (naksIgnored, naksShed and naksIgnoredRetransmitDelay) may begin to inflate, and retransmissions retransmissionsSent) may become significantly lower than NAKS received (naksReceived). This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Number of datagrams retransmitted by this source.

long com.latencybusters.lbm.LBMSourceStatistics.retransmissionsSent | ( | int | n | ) |

Number of datagrams retransmitted by this source (LBT-RM, LBT-RU).

This count is incremented under the same circumstances as retransmissionBytesSent, below. In a normal, light-loss scenario, most NAKs received induce a retransmission. When losses become heavy and/or many receiver transports begin losing the same datagrams, NCF-related no-retransmit counts (naksIgnored, naksShed and naksIgnoredRetransmitDelay) may begin to inflate, and retransmissions retransmissionsSent) may become significantly lower than NAKS received (naksReceived). This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of datagrams retransmitted by this source.

int com.latencybusters.lbm.LBMSourceStatistics.size | ( |  | ) |

Number of statistical sets encapsulated within this object.

Returns
  Statistical set size

string com.latencybusters.lbm.LBMSourceStatistics.source | ( |  | ) |

Source of transport as a string.

This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class. The string format depends on transport type and is described under LBMTransportSourceInfo.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Source of transport as a string

string com.latencybusters.lbm.LBMSourceStatistics.source | ( | int | n | ) |

Source of transport as a string.

This method returns a value from the nth set of statistics encapsulated within this object. The string format depends on transport type and is described under LBMTransportSourceInfo.

See also
  LBMTransportSourceInfo

Parameters

  n | Statistics set index

Returns
  Source of transport as a string

long com.latencybusters.lbm.LBMSourceStatistics.transmissionWindowBytes | ( |  | ) |

Number of bytes currently in the transmission window (LBT-RM only)

Number of bytes currently in the transmission window. Typically, this count approaches its window size or exceeds it by a small amount. See transmissionWindowMessages for a description of the transmission window. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Number of bytes currently in the transmission window

long com.latencybusters.lbm.LBMSourceStatistics.transmissionWindowBytes | ( | int | n | ) |

Number of bytes currently in the transmission window (LBT-RM only)

Number of bytes currently in the transmission window. Typically, this count approaches its window size or exceeds it by a small amount. See transmissionWindowMessages for a description of the transmission window. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of bytes currently in the transmission window

long com.latencybusters.lbm.LBMSourceStatistics.transmissionWindowMessages | ( |  | ) |

Number of datagrams in the transmission window (LBT-RM only).

Each source transport session maintains a transmission window buffer (the size of which is set by transport_lbtrm_transmission_window_size, default 24MB). When the source transport receives a NAK, the corresponding message for retransmission must be found in this transmission window. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Number of datagrams in the transmission window.

long com.latencybusters.lbm.LBMSourceStatistics.transmissionWindowMessages | ( | int | n | ) |

Number of datagrams in the transmission window (LBT-RM only).

Each source transport session maintains a transmission window buffer (the size of which is set by transport_lbtrm_transmission_window_size, default 24MB). When the source transport receives a NAK, the corresponding message for retransmission must be found in this transmission window. This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Number of datagrams in the transmission window.

int com.latencybusters.lbm.LBMSourceStatistics.type | ( |  | ) |

Transport type (TCP, LBT-RM, LBT-RU, etc.)

This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)
  LBM

Returns
  Transport type

int com.latencybusters.lbm.LBMSourceStatistics.type | ( | int | n | ) |

Transport type (TCP, LBT-RM, LBT-RU, etc.)

This method returns a value from the nth set of statistics encapsulated within this object.

See also
  LBM

Parameters

  n | Statistics set index

Returns
  Transport type

string com.latencybusters.lbm.LBMSourceStatistics.typeName | ( |  | ) |

Transport type name (TCP, LBT-RM, LBT-RU, etc.).

This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMSourceStatistics(LBMSource)

Returns
  Transport type name

string com.latencybusters.lbm.LBMSourceStatistics.typeName | ( | int | n | ) |

Transport type name (TCP, LBT-RM, LBT-RU, etc.).

This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Transport type name

References com.latencybusters.lbm.LBM.TRANSPORT_STAT_BROKER, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTIPC, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRDMA, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRM, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRU, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTSMX, and com.latencybusters.lbm.LBM.TRANSPORT_STAT_TCP.

The documentation for this class was generated from the following file:

- LBMSourceStatistics.cs